<?php

namespace IdelibreApiPhp\Tests\Api;

use IdelibreApiPhp\Api\v2\PartyApiWrapper;
use IdelibreApiPhp\Client;
use IdelibreApiPhp\Enum\ApiPath;
use IdelibreApiPhp\Model\Party;
use IdelibreApiPhp\Tests\Mocker\ClientMock;
use PHPUnit\Framework\MockObject\Exception;
use PHPUnit\Framework\TestCase;
use Psr\Http\Client\ClientExceptionInterface;
use Symfony\Component\PropertyInfo\Extractor\ReflectionExtractor;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Exception\ExceptionInterface;
use Symfony\Component\Serializer\Normalizer\ArrayDenormalizer;
use Symfony\Component\Serializer\Normalizer\DateTimeNormalizer;
use Symfony\Component\Serializer\Normalizer\GetSetMethodNormalizer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Serializer;

class PartyApiWrapperTest extends TestCase
{

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->clientMock = new ClientMock(Client::class);
        $objectNormalizer = new ObjectNormalizer(null, null, null, new ReflectionExtractor());
        $getSetNormalizer = new GetSetMethodNormalizer();
        $dateTimeZoneNormalizer = new DateTimeNormalizer([DateTimeNormalizer::TIMEZONE_KEY => 'UTC']);
        $this->serializer = new Serializer([$objectNormalizer, $getSetNormalizer, new ArrayDenormalizer(),$dateTimeZoneNormalizer], [new JsonEncoder()]);
        $this->userApi = $this->clientMock->isApiUser();
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testGetAll()
    {
        $apiResponse = '[
            {"id":"cf700183-b77b-483b-baca-b67f188d57e0","name":"Les Verts Ecologie","initials":"LVE","createdAt":"2024-04-25T12:05:56+00:00","updatedAt":"2024-04-25T12:05:56+00:00"},
            {"id":"954daf3b-a34c-47f4-b647-979444d796a9","name":"Renaissance","initials":"rnc","createdAt":"2024-09-09T07:33:42+00:00","updatedAt":"2024-09-09T07:33:42+00:00"}
        ]';

        $structureId = $this->userApi->getStructure()->getId(); ;
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/parties', $structureId ) ,$apiResponse);


        $expected  = [];
        foreach (json_decode($apiResponse, true) as $party) {
            $expected[] = $this->serializer->denormalize($party, Party::class);
        }

        $partyApiWrapper = new PartyApiWrapper($clientMock);
        $response = $partyApiWrapper->getAll();

        $this->assertEquals($expected, $response);
        $this->assertCount(2, $response);
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testGetOne()
    {
        $apiResponse = '{"id":"cf700183-b77b-483b-baca-b67f188d57e0","name":"Les Verts Ecologie","initials":"LVE","createdAt":"2024-04-25T12:05:56+00:00","updatedAt":"2024-04-25T12:05:56+00:00"}';

        $structureId = $this->userApi->getStructure()->getId();
        $partyId = json_decode($apiResponse, true)['id'];
        $clientMock = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/parties/' . $partyId, $structureId) ,$apiResponse);

        $expected = $this->serializer->deserialize($apiResponse, Party::class, 'json');
        $partyApiWrapper = new PartyApiWrapper($clientMock);
        $response = $partyApiWrapper->getOne($partyId);

        $this->assertInstanceOf(Party::class, $response);
        $this->assertEquals($expected, $response);

    }

    /**
     * @throws ExceptionInterface
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testCreate()
    {
        $apiResponse = '{"id":"cf700183-b77b-483b-baca-b67f188d57e0","name":"Les Verts Ecologie","initials":"LVE","createdAt":"2024-04-25T12:05:56+00:00","updatedAt":"2024-04-25T12:05:56+00:00"}';

        $structureId = $this->userApi->getStructure()->getId();
        $clientMock = $this->clientMock->mockClient('post', sprintf(ApiPath::BASE_API_V2_PATH . '/parties', $structureId), $apiResponse );

        $expected = $this->serializer->deserialize($apiResponse, Party::class, 'json');

        $partyApiWrapper = new PartyApiWrapper($clientMock);
        $response = $partyApiWrapper->create($expected);

        $this->assertEquals($expected, $response);
        $this->assertInstanceOf(Party::class, $response);
    }


    /**
     * @throws ExceptionInterface
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testEdit()
    {
        $apiResponse = '{"id":"cf700183-b77b-483b-baca-b67f188d57e0","name":"Les Verts Ecologie","initials":"LVE","createdAt":"2024-04-25T12:05:56+00:00","updatedAt":"2024-04-25T12:05:56+00:00"}';

        $structureId = $this->userApi->getStructure()->getId();
        $partyId = json_decode($apiResponse, true)['id'];
        $clientMock = $this->clientMock->mockClient('put', sprintf(ApiPath::BASE_API_V2_PATH . '/parties/' . $partyId, $structureId), $apiResponse );

        $expected = $this->serializer->deserialize($apiResponse, Party::class, 'json');

        $partyApiWrapper = new PartyApiWrapper($clientMock);
        $response = $partyApiWrapper->edit($expected);

        $this->assertEquals($expected, $response);
        $this->assertInstanceOf(Party::class, $response);
    }


    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testDelete()
    {
        $party = '{"id":"cf700183-b77b-483b-baca-b67f188d57e0","name":"Les Verts Ecologie","initials":"LVE","createdAt":"2024-04-25T12:05:56+00:00","updatedAt":"2024-04-25T12:05:56+00:00"}';

        $structureId = $this->userApi->getStructure()->getId();
        $partyId = json_decode($party, true)['id'];


        $clientMock = $this->clientMock->mockClient('delete', sprintf(ApiPath::BASE_API_V2_PATH . '/parties/' . $partyId, $structureId), $party);
        $partyApiWrapper = new PartyApiWrapper($clientMock);
        $response = $partyApiWrapper->delete($partyId);

        $this->assertEquals(204, $response);
    }
}
